config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'
  
resources :articles do
  resources :comments
end

resources:users
  root 'welcome#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
  has_many :comments, dependent: :destroy
  validates :title, presence: true,
                    length: { minimum: 5 }
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :article
end

app/models/user.rb
class User < ApplicationRecord
  validates :id, presence: true,
                    length: { maximum: 3 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  include HttpAuthConcern
  protect_from_forgery with: :exception
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
 
 # http_basic_authenticate_with name: "id", password: "name", except: [:index, :show]
 
#snippet for brevity
  def index
    @articles = Article.all
  end
  def show
    @article = Article.find(params[:id])
  end
  def new
  	@article = Article.new
  end
  def edit
  	@article = Article.find(params[:id])
  end
  
  def create
  	@article = Article.new(article_params)
 
  if @article.save
    redirect_to @article
  else
    render 'new'
  end
  end
 
  def update
  @article = Article.find(params[:id])
 
  if @article.update(article_params)
    redirect_to @article
  else
    render 'edit'
  end
  end
  def destroy
    @article = Article.find(params[:id])
    @article.destroy
 
    redirect_to articles_path
  end
  private
  def article_params
    params.require(:article).permit(:title, :text)
  end 
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController

#  http_basic_authenticate_with name: "id", password: "name", only: :destroy
  
  def create
    @article = Article.find(params[:article_id])
    @comment = @article.comments.create(comment_params)
    redirect_to article_path(@article)
  end
 
  def destroy
    @article = Article.find(params[:article_id])
    @comment = @article.comments.find(params[:id])
    @comment.destroy
    redirect_to article_path(@article)
  end
 
  private
    def comment_params
      params.require(:comment).permit(:commenter, :body)
    end
end

app/controllers/concerns/http_auth_concern.rb
module HttpAuthConcern  
    extend ActiveSupport::Concern
    included do
        before_action :http_authenticate
    end
    def http_authenticate
        return true unless Rails.env == 'production'
        authenticate_or_request_with_http_basic do |username, password|
            username == 'id' && password == 'name'
        end
    end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
	def index
    @users = User.all
    end
    def show
    @user = User.find(params[:id])
    end
	def new
	@user = User.new
	end
	def edit
    @user = User.find(params[:id])
    end
    def create
  	@user = User.new(user_params)
 	if @user.save
    	redirect_to @user, flash: {success: "New account registration is successful, please login"}
  	else
    	render 'new'
  	end
  	end

    end
	def edit
  	@user = User.find(params[:id])
	end
	
	def user_params
    params.require(:user).permit(:id, :name)
  	end
  	
  	def destroy
    @user = User.find_by_id(params[:id])
    @user.destroy
    redirect_to users_path(new: false), flash: {success: "User has deleted"}
    end
    
    private
    def user_params
    params.require(:user).permit(:id, :name)
    end
    def logged_in
    unless logged_in?
      redirect_to root_url, flash: {danger: 'Please log in'}
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/articles/_form.html.erb
<%= form_for @article do |f| %>
 
  <% if @article.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@article.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @article.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <p>
    <%= f.label :title %><br>
    <%= f.text_field :title %>
  </p>
 
  <p>
    <%= f.label :synopsis %><br>
    <%= f.text_area :text %>
  </p>
 
  <p>
    <%= f.submit %>
  </p>
 
<% end %>

app/views/articles/edit.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<div class="container">
  <ul class="list-group">
<h1>Edit article</h1>
 
<li class="list-group-item"><%= render 'form' %><span class="badge"></span></li>
 
<li class="list-group-item"><%= link_to 'Back', articles_path %><span class="badge"></span></li>
  </ul>
</div>

app/views/articles/index.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<body>

<div class="container">
<h1>Listing Films</h1>
<%= link_to 'New Film', new_article_path %>
<%= link_to 'New user', new_user_path %>
  <table class="table">
  <tr>
    <th>Title</th>
    <th>Synopsis</th>
    <th colspan="3"></th>
  </tr>
 
  <% @articles.each do |article| %>
    <tr>
      <td><%= article.title %></td>
      <td><%= article.text %></td>
      <td><%= link_to 'Show', article_path(article) %></td>
      <td><%= link_to 'Edit', edit_article_path(article) %></td>
      <td><%= link_to 'Destroy', article_path(article),
              method: :delete,
              data: { confirm: 'Are you sure?' } %></td>
    </tr>
  <% end %>
</table>

</div>

</body>
</html>

app/views/articles/new.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>

<div class="container">
  <ul class="list-group">
<h1>New Film</h1>
 
<li class="list-group-item"><%= render 'form' %><span class="badge"></span></li>
 
<li class="list-group-item"><%= link_to 'Back', articles_path %><span class="badge"></span></li>
  </ul>
</div>

app/views/articles/show.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <ul class="list-group">
  <h2>Film</h2>
    <li class="list-group-item">Title: <%= @article.title %><span class="badge"></span></li>
    <li class="list-group-item">Text: <%= @article.text %> <span class="badge"></span></li>
    <h2>Comments</h2>
	<li class="list-group-item"><%= render @article.comments %><span class="badge"></span></li>
	<h2>Add a comment:</h2>
	<li class="list-group-item"><%= render 'comments/form' %><span class="badge"></span></li>
  </ul>
</div>

</body>
</html>


 <div class="container">
  <ul class="list-group">
  <li class="list-group-item">
<%= link_to 'Edit', edit_article_path(@article) %> |
<%= link_to 'Back', articles_path %>
</li>
</ul>
</div>

app/views/comments/_comment.html.erb
<hr>
<p>
  <strong>Id:</strong>
  <%= comment.commenter %>
</p>
 
<p>
  <strong>Comment:</strong>
  <%= comment.body %>
</p>
 

<p>
  <%= link_to 'Destroy Comment', [comment.article, comment],
               method: :delete,
               data: { confirm: 'Are you sure?' } %>
</p>
</hr>

app/views/comments/_form.html.erb
<%= form_for([@article, @article.comments.build]) do |f| %>
  <p>
    <%= f.label :Id %><br>
    <%= f.text_field :commenter %>
  </p>
  <p>
    <%= f.label :Comment %><br>
    <%= f.text_area :body %>
  </p>
  <p>
    <%= f.submit %>
  </p>
<% end %>

app/views/layouts/_content.html.erb
<br>
<div class="container">
  <% flash.each do |message_type, message| %>
      <div class="alert alert-<%= message_type %>">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        <strong> <%= message %></strong>
      </div>
  <% end %>
</div>

<%= yield %>

app/views/layouts/_header.html.erb
<nav class="navbar navbar-inverse navbar-fixed-top">
  <div class="container">

    <div class="navbar-header">
      <%= link_to "Welcome", root_path, class: 'navbar-brand' %>
      <%= link_to "Films", articles_path, class: 'navbar-brand' %>
    </div>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>CourseSelect</title>
  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <meta>
  <meta name="renderer" content="webkit">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <%= csrf_meta_tags %>
</head>

<body class="<%= "body-background" if params[:controller]!="homes" %>">

<%= render partial: 'layouts/header' %>
<%= render partial: 'layouts/content' %>

</body>
</html>

app/views/users/_form.html.erb
<%= form_for @user do |f| %>
 
  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@user.errors.count, "error") %> prohibited
        this user from being saved:
      </h2>
      <ul>
        <% @user.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <p>
    <%= f.label :id %><br>
    <%= f.text_field :id %>
  </p>
 
  <p>
    <%= f.label :name %><br>
    <%= f.text_area :name %>
  </p>
 
  <p>
    <%= f.submit %>
  </p>
 
<% end %>

app/views/users/index.html.erb
<h1>Hello, Rails!</h1>

app/views/users/new.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<div class="container">
  <ul class="list-group">
<h1>New User</h1>
 
<li class="list-group-item"><%= render 'form' %><span class="badge"></span></li>
 
<li class="list-group-item"><%= link_to 'Back', articles_path %><span class="badge"></span></li>
  </ul>
</div>

app/views/users/show.html.erb
<p>
  <strong>Id:</strong>
  <%= @user.id %>
</p>
 
<p>
  <strong>Name:</strong>
  <%= @user.name %>
</p>

<%= link_to 'Edit', edit_user_path(@user) %> |
<%= link_to 'Back', articles_path %>

app/views/welcome/index.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<div class="container">


  <div class="row">
    <div class="col-md-8" style=padding-bottom: 10px;padding-top: 10px">
      <div style="font-size: 50px; padding-left: 50px">
        <%= image_tag "image.jpg" %>
        Welcome to MTIME!
      </div>

    </div>

</div>